#include <iostream>
#include <boost/shared_ptr.hpp>

using namespace std;
using namespace boost;

class X {
public:
  virtual void print() const {
    std::cout << "I'm a X" <<std::endl;
  }
  
  X(int x=0): _x(x) {}

private:
  int _x;
};

class Y :public X {
public:
  Y(int x=0): X(x){}
  virtual void print() const {
    std::cout << "I'm a Y" <<std::endl;
  }
};


void f(shared_ptr<X> x) {
  x->print();
}

void g(shared_ptr<Y> x) {
  x->print();
}

void f(X& x) {
  x.print();
}
void g(Y& x) {
  x.print();
}

//downcast upcast


int
main() {

  shared_ptr<X> x(new X);
  shared_ptr<X> y1(new Y);
  shared_ptr<Y> y2(new Y);


  // upcast and no cast
  f(x);
  f(y1);
  f(y2);
  g(y2);
  f(*x);
  f(*y1);
  f(*y2);
  g(*y2);

  // downcast
  g(dynamic_pointer_cast<Y>(y1));
  g(dynamic_cast<Y&>(*y1));


  return 0;
}
