#include <boost/utility/enable_if.hpp>
#include <vector>
#include <list>
#include <boost/concept_check.hpp>
#include <iterator>
#include <boost/static_assert.hpp>
#include <boost/type_traits.hpp>
#include <boost/iterator/iterator_traits.hpp>
#include <iostream>

using namespace std;
using namespace boost;


template<class Iter>
typename enable_if_c<is_same<typename iterator_traits<Iter>::iterator_category, random_access_iterator_tag>::value, Iter >::type
my_advance(Iter& iterator, unsigned  distance) {
  iterator+=distance;
  return iterator;
}


template<class Iter>
typename enable_if_c<! is_same<typename iterator_traits<Iter>::iterator_category, random_access_iterator_tag>::value, Iter >::type
my_advance(Iter& iterator, unsigned distance) {
  for (unsigned i=0; i < distance; ++i) {
    ++iterator;
  }
  return  iterator;
}



class X {};
class Y:public X{};
class Z {};
int
main() {
  
  vector<int> v;  
  list<int> l;
  
  for (unsigned int i=0; i < 5; ++i){
    v.push_back(i);
    l.push_back(i);
  }

  list<int>::iterator li=l.begin();
  vector<int>::iterator vi=v.begin();    


  my_advance(vi,2);
  my_advance(li,2);


    
  return 0;
}
