#include <iostream>
#include <boost/type_traits.hpp>
#include <boost/concept_check.hpp>
#include <boost/concept/requires.hpp>

#include <cstring>
#include <algorithm>
#include <vector>
#include <list>

using namespace std;
using namespace boost;

template<typename Type, int size> 
struct HasSize {
  static const bool  value =(sizeof(Type)==size);

private:
  Type t;
};

template<class Iter>
BOOST_CONCEPT_REQUIRES(
	       ((RandomAccessIterator<Iter>))
	       ((HasSize<typename RandomAccessIterator<Iter>::value_type, 1>))
	       ,(void))
my_fill(Iter begin, Iter end, typename iterator_traits<Iter>::value_type val) {
  memset(&(*begin), val, end-begin);
  cout << "memset" <<endl;
}

template<class T>
void print_elmt(const T& t) {
  cout << t << endl;
}

int
main() {
  
  std::vector<int> vi;
  std::vector<char> vc;
  std::list<char> li;
  for (unsigned i=0; i < 5; ++i) {
    vi.push_back(5);
    vc.push_back('c');
    vc.push_back('c');
  }

  //  for_each(vi.begin(), vi.end(), print_elmt<int>);
  //for_each(vc.begin(), vc.end(), print_elmt<char>);  
  //for_each(li.begin(), li.end(), print_elmt<char>);  
  my_fill(vi.begin(), vi.end(), 2);
  my_fill(vc.begin(), vc.end(), 'd');
  //my_fill(li.begin(), li.end(), 'd');
  //for_each(vi.begin(), vi.end(), print_elmt<int>);
  //for_each(vc.begin(), vc.end(), print_elmt<char>);  
  //for_each(li.begin(), li.end(), print_elmt<char>);

  return 0;
}
